//script written by Lighto is reusablesh
freeslot("MT_TUHISPINNER") 

addHook("MobjSpawn",function(mo)
	
	--mo.scale = FRACUNIT*3
	mo.THSPNR = {initz=mo.z,isactive=false,initang=mo.angle,mvspd=0,maxheight=1024*FRACUNIT,hardup=false}
	mo.thspinnercd = 0
end,MT_TUHISPINNER)

addHook("MobjThinker",function(mo)
	mo.thspinnercd = max(0,$-1)
	if mo.THSPNR.isactive == true
	and mo.target.player.isinspinnergimmick == true
	and mo.target ~= nil then
		local p = mo.target.player
		local pmo = p.mo
		p.pflags = $ |PF_FULLSTASIS
		pmo.flags = $ |MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_NOBLOCKMAP
		local d,dx,dy,vd
		d = (mo.radius +1) *2 --(mo.radius + pmo.radius + 1 ) 
		dx = mo.x+FixedMul(d,cos(mo.angle)) 
		dy = mo.y+FixedMul(d,sin(mo.angle)) 
		pmo.flags2 = $ | MF2_DONTDRAW
		P_TeleportMove(pmo,mo.x,mo.y,mo.z-mo.height/8) -- PLAYER
		local s = P_SpawnMobj(dx,dy,mo.z-mo.height/8,MT_THOK)
		s.frame = pmo.frame
		s.state = pmo.state
		s.skin = pmo.skin
		s.fuse = 2
		s.color = p.skincolor
		s.angle = mo.angle+ANGLE_90
		if mo.THSPNR.hardup == false then
			mo.z=$+mo.THSPNR.mvspd/(1+((mo.THSPNR.maxheight/FRACUNIT)/800))
		else
			mo.z=$+(mo.THSPNR.mvspd/(1+((mo.THSPNR.maxheight/FRACUNIT)/800)))/8
		end	
		mo.angle = $ + (mo.THSPNR.mvspd/FRACUNIT)*ANG1
		vd = abs(mo.z - mo.THSPNR.initz)
		mo.THSPNR.mvspd = $ - (FRACUNIT/3)
		pmo.angle = $ + (mo.THSPNR.initang-pmo.angle)/8
		if vd > mo.THSPNR.maxheight --then
		or mo.THSPNR.mvspd < 15*FRACUNIT then
			p.kartstuff[k_pogospring] = 2
			P_InstaThrust(pmo,mo.THSPNR.initang,mo.THSPNR.mvspd)
			pmo.momz = 16*FRACUNIT
			p.pflags = $ & ~ PF_FULLSTASIS
			pmo.flags = $ & ~ (MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_NOBLOCKMAP)
			p.isinspinnergimmick = false
			d = (mo.radius + pmo.radius  + 1 )
			mo.angle = mo.THSPNR.initang
			pmo.angle = mo.THSPNR.initang
			p.thlastspinner.thspinnercd = 16
			--dx = mo.x+FixedMul(d,cos(mo.angle)) 
			--dy = mo.y+FixedMul(d,sin(mo.angle)) 
			--P_TeleportMove(pmo,dx,dy,mo.z)
			--P_ResetPlayer(p)
			P_RemoveMobj(mo)
			
		end
		if not pmo or pmo and not pmo.valid
		or p.spectator then
		
			p.isinspinnergimmick = false
			if not mo or mo and not mo.valid then return end
			P_RemoveMobj(mo)
		end
	end

end,MT_TUHISPINNER)


addHook("TouchSpecial",function(mt,mt2)
	if not mt
	or mt.THSPNR.isactive == true
	or mt.target == mt2
	or mt.thspinnercd > 0
	or not mt2
	or not mt2.player
	or not mt2.player.valid
	or mt2.player.isinspinnergimmick == true
	--or mt2.player.speed < 30 * FRACUNIT
	or mt2.player.kartstuff[k_spinouttimer] then return true end
	
	local sp
	sp = P_SpawnMobj(mt.x,mt.y,mt.z,MT_TUHISPINNER)
	sp.THSPNR.isactive = true
	sp.THSPNR.mvspd = mt2.player.speed+(2*FRACUNIT)
	mt2.player.isinspinnergimmick = true
	sp.target = mt2
	mt2.momx,mt2.momy ,mt2.momz= 0,0,0
	local spni = mt.spawnpoint.extrainfo + 1
	sp.THSPNR.maxheight=500*spni * FRACUNIT
	sp.THSPNR.initang= mt.angle
	mt.state = mt.info.spawnstate
	mt.health = 1000
	mt.spawnhealth = 1000
	mt2.player.thlastspinner = mt
	if mt.spawnpoint.options & 1 then
		--sp.THSPNR.mvspd = $ / 3
		sp.THSPNR.hardup = true
		if mt2.player.kartstuff[k_sneakertimer]
		or mt2.player.kartstuff[k_growshrinktimer] > 0
		or mt2.player.kartstuff[k_invincibilitytimer] then
			--sp.THSPNR.mvspd = $ * 6
			sp.THSPNR.hardup = false
		end
		
	end
	S_StartSound(mt,sfx_s3k4a)
	return true

end,MT_TUHISPINNER)